<?php
/**
 * An Administration Plugin sending messages to many users at one glimpse.
 *
 * @package     virtUOS
 * @subpackage  administration
 *
 * @author    aklassen
 * @copyright (c) Authors
 * @version   $Id$
 */

class MultiMess extends AbstractStudIPAdministrationPlugin {


  function MultiMess() {

    parent::AbstractStudIPAdministrationPlugin();

    $this->setPluginiconname("img/plugin.png");

    # navigation
    $navigation =& new PluginNavigation();
    $navigation->setDisplayname(_("MultiMess (Nachricht an viele Benutzer) "));
    $this->setNavigation($navigation);


    ## AbstractStudIPAdministrationPlugin specifics

    # top navigation
    $top_navigation =& new PluginNavigation();
    $top_navigation->setDisplayname(_("MultiMess"));
    $this->setTopnavigation($top_navigation);
  }


  function initialize() {
   // printf("in %s:%s\n", __CLASS__, __FUNCTION__);
  }


  function getPluginname() {
    return _("MultiMess ");
  }


  function actionShow() {
  	/*
	admin_user_message.php
	Copyright (C) 2005 Andr Noack <noack@data-quest.de>
	Suchi & Berg GmbH <info@data-quest.de>
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA	02111-1307, USA.
	*/


	
	global $perm;
	global $sess;
	
	
	
	
	if($GLOBALS["SOFTWARE_VERSION"] == "Stud.IP 1.1.5-OS-1"){
		require_once("msg.inc.php");
		require_once("functions.php");
		require_once("messaging.inc.php");
		
	}
	else {
		require_once("lib/msg.inc.php");
		require_once("lib/functions.php");
		require_once("lib/messaging.inc.php");
	}
		
		
	//echo $GLOBALS["SOFTWARE_VERSION"];
	require_once("lib/classes/UserManagement.class.php");


	function MyMakeButton ($name, $mode = "img", $tooltip = false, $inputname = false) {
		global $_language_path, $CANONICAL_RELATIVE_PATH_STUDIP;
		$path = "{$CANONICAL_RELATIVE_PATH_STUDIP}locale/$_language_path/LC_BUTTONS";
		$tooltext = ($tooltip ? tooltip($tooltip) : '');
		if ($mode == "img")
			$tag = sprintf ("\n<img src=\"%s/%s-button.gif\" %s border=\"0\" align=\"absmiddle\"/>", $path, $name, $tooltext);
		elseif ($mode == 'input')
			$tag = sprintf ("\n<input type=\"image\" src=\"%s/%s-button.gif\" %s border=\"0\" name=\"%s\" align=\"absmiddle\"/>", $path, $name, $tooltext, $inputname);
		else
			$tag = sprintf ("src=\"%s/%s-button.gif\"", $path, $name);

		return $tag;
	}

	page_open(array("sess" => "Seminar_Session", "auth" => "Seminar_Auth", "perm" => "Seminar_Perm", user => "Seminar_User"));
	$perm->check("root");

	$sess->register('_message_user');
	$db = new DB_Seminar();



	$msg = array();

	//-- hier muessen Seiten-Initialisierungen passieren --
	if (isset($_REQUEST['cancel_x'])){
		$_message_user = array();
	}
	if (isset($_REQUEST['userlist_submit_x']) && trim($_REQUEST['message_user_list'])){
		$_message_user = preg_split("/[\s,;]+/", $_REQUEST['message_user_list'], -1, PREG_SPLIT_NO_EMPTY);
		$_message_user = array_flip($_message_user);
		$db->query("SELECT * FROM auth_user_md5 WHERE username IN ('".join("','", array_keys($_message_user))."')");
		while($db->next_record()){
			$_message_user[$db->f('username')] = $db->Record;
			$_message_user[$db->f('username')]['selected'] = true;
		}
		$_message_user = array_filter($_message_user, 'is_array');
		$msg[] = array('msg', sprintf(_("%s Nutzer gefunden"), count($_message_user)));
	}
	if (isset($_REQUEST['message_accounts_x']) && check_ticket($_POST['studipticket'])){
		$msging=new Messaging();
		foreach($_message_user as $uname => $udetail){
			if (isset($_REQUEST['selected_user'][$uname])){
				$msging->insert_message($message, $uname,'', '', '', '', '', $subject);
				echo "<br />Nachricht an $uname versandt.";
			}
		}
	}


	$i_page = 'new_user_md5.php';


	?>
	<table border="0" align="center" cellspacing="0" cellpadding="0" width="100%">
		<tr>
			<td class="blank">&nbsp;</td>
		</tr>
		<?
		if (count($msg)){
			echo "\n<tr><td class=\"blank\"><table width=\"99%\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">";
			parse_msg_array($msg, "blank", 1 ,false);
			echo "\n</table></td></tr>";
		}
		?>
		<tr>
		<td class="blank">
		<div style="margin-left:20px;font-size:10pt;">
		<form action="<?=PluginEngine::getLink($this, array("userlist_submit"=> 1), "show")?>" method="POST">
		<?=_("Geben sie eine Liste von Nutzernamen (username) ein, an die eine Nachricht verschickt werden soll. Die Namen k&ouml;nnen mit Komma, Semikolon, oder whitespaces getrennt sein.")?>
		<br><br>
		<textarea name="message_user_list" rows="10" cols="80" wrap="virtual"><?=(is_array($_message_user) ? join("\n", array_keys($_message_user)): '')?></textarea>
		<br><br><br>
		<?=MyMakeButton('absenden', $mode = "input", $tooltip = _("Namen berprfen"), 'userlist_submit')?>
		&nbsp;
		<?=MyMakeButton('zuruecksetzen', $mode = "input", $tooltip = _("Zurcksetzen"), 'cancel')?>
		<br>
		</form>
		</div>
		</td>
		</tr>
		<tr>
			<td class="blank">&nbsp;</td>
		</tr>

		<?
		if (count($_message_user)){
			$cssSw = new cssClassSwitcher();
			$cssSw->enableHover();
			echo '<tr><td class="blank">';
			echo '<form name="admin_user_message" method="POST" action="'.PluginEngine::getLink($this, array("message"=> 1), "show").'">';
			echo '<input type="hidden" name="studipticket" value="'.get_ticket().'">';
			echo '<div style="margin-left:20px;font-size:10pt;">';
			echo '<table cellpadding="2" cellspacing="0" bgcolor="#eeeeee"  width="85%">';
			foreach($_message_user as $username => $userdetail){
				echo chr(10).'<tr  ' . $cssSw->getHover().'><td ' . $cssSw->getFullClass() . '><b>'
					. '<a href="new_user_md5.php?details='.$username.'">'.$username . '</a></b></td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady( $userdetail['Vorname'] . ' ' . $userdetail['Nachname'] . ' ('.$userdetail['perms'].')').'</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['Email']) . '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['auth_plugin']) . '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '><input type="checkbox" value="1" name="selected_user['.$username.']" '
					.($userdetail['selected'] ? ' checked ' : '') .'></td>';
				echo chr(10).'</tr>'; 
				$cssSw->switchClass();
			}
			echo chr(10).'<tr><td colspan="5" class="blank">&nbsp;</td></tr>';
			echo chr(10).'<tr><td colspan="2" class="blank"><font size="-1">Betreff:</FONT></td><td colspan="3"><input type="text" name="subject" size="80"></td></tr>';
			echo chr(10).'<tr><td colspan="5" class="blank"><font size="-1">Nachricht:</FONT></td></tr>';
			echo chr(10).'<tr><td colspan="5" class="blank"><textarea name="message" cols="80" rows="15"></textarea></td></tr>';
	?>
			<tr><td class="blank" colspan="5" align="right"> 
			<?=MyMakeButton('abschicken', $mode = "input", $tooltip = _("Ausgew&auml;hlten Personen Mail schicken"), 'message_accounts')?>
			</td>
			</tr>
			<?
			echo '</table></div></td></tr>';
		}
		?>
		<tr>
			<td class="blank">&nbsp;</td>
		</tr>
	</table>
	<?
	
  }


  function actionShowAdministrationPage() {
 
  }
}
